/*****************************/
/* Inside The Machine - MKS  */
/*****************************/

//Jaunty entity File
#ifndef _EBOSS3_H
#define _EBOSS3_H

//Includes
#include "Entity.h"
#include "../µsprite.h"

//Defines

//Paramètres du boss
// TYPE : static
// p1 et p2 : 
// Autres :

struct sBalls3
{
	int x, y;
	int vx, vy;
	sHitBoxRect rect;
	bool free;  
};
   
class eBoss3 : public CEntity
{
   public:
   	eBoss3();
   	virtual ~eBoss3();
   	virtual void Draw(int layer);
	   virtual void Update();
	   virtual void Destroy();
	   virtual void Load();
	   virtual void CheckInteractions();
	   
	public:
	   //Sprites
	CSprite body;       //Sprite du boss (Dubosc haha :noel:)
	CSprite explosion;  //Explosion
	CSprite bigball;    //bigball
	CSprite sprFx2;     //FX no 2
	int orix, oriy;     //Position originale en x, y
	
	bool isBossActivated;
	int sequence;       //0 Idle Center (touché aux fireballs), 1 Balls, 2 Moving, 3 Torpille
	int timer;          //Idle : 3 secs - 3 sec - 4sec - 8sec
							  //Phase bien déterminée
							  //Life > 100 : Idle - Balls - Idle - Rotate
							  //Life < 100 : Idle - Balls - Idle - Rotate - Torpille 
	bool canFight, hit;
	int hitTime;
	sBalls3 balls[12];    //Boulettes que tire l'ennemi
	int explosionH;
	int explosionAlpha;
	bool side;
	bool canFireball;
	u16 angle;
	bool tour;
	
	   
};
#endif
